#!/usr/bin/php -q
<?
/*
	Peagle Search
	Version 0.2.1
	Relesed April 26 2006
	
	PHP-Web-Frontend for Beagle (Php bEAGLE)
	Created and Copyright by Martin Eitzenberger <m.eitzenberger@unix.net>
	Website: http://www.psiplus.at
	
	You are free to use and alter this script by the terms of the GNU GPL,
	but please inform me if you plan to release it on your own / public an
	improved/altered version - I'll put a link on my website :-)
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

global $set;global $preset;
require("settings.php");

/*
	These are _only_ presets... Don't modify them if you don't need
  to modify them...
  
  Please note:
  
  These are NOT the Settings from elder Peagle-Versions, these
  Settings are now located in settings.php!!
*/
$preset=array
(
	"app_name"=>"Peagle",
	"app_version"=>"0.2.1",
	"app_date"=>"26.04.2006",
	
	"desktops"=>array("auto","kde","gnome","link","mailcap","custom"),
);

search_init();
server_run();

function do_status()
{
	?>
		<div class="leadline_t">
			Status
		</div>
	<?
	
	exec("beagle-info --status",$r);
	
	$curr="";
	while(list(,$t)=each($r))
	{
		list($x,$y)=explode(":",$t,2);
		$x=trim($x);$y=trim($y);
		if($x=="Scheduler"||$x=="Pending Tasks"||$x=="Future Tasks"||$x=="Blocked Tasks")
		{
			$curr=$x;
		}
		else switch($curr)
		{
			case "Scheduler":
				$sched.="<div>".htmlentities($t)."</div>";
			break;
			case "Pending Tasks":
				$pend.="<div>".htmlentities($t)."</div>";
			break;
			case "Future Tasks":
				$fut.="<div>".htmlentities($t)."</div>";
			break;
			case "Blocked Tasks":
				$blck.="<div>".htmlentities($t)."</div>";
			break;
		}
	}
	
	?><div>
		<?if($sched){?>
		<br /><div><b>Scheduler-Status</b></div>
		<?=$sched?>
		<?}?>
		
		<?if($pend){?>
		<br /><div><b>Pending Tasks</b></div>
		<?=$pend?>
		<?}?>
		
		<?if($fut){?>
		<br /><div><b>Future Tasks</b></div>
		<?=$fut?>
		<?}?>
		
		<?if($blck){?>
		<br /><div><b>Blocked Tasks</b></div>
		<?=$blck?>
		<?}?>
		
		</div>
	<?
	$did=true;
}

function do_sindex()
{
	?>
		<div class="leadline_t">
			Index-Info
		</div>
	<?
	
	exec("beagle-info --index-info",$r);
	
	$list=array();
	
	while(list(,$t)=each($r))
	{
		list($x,$y)=explode(":",$t,2);
		$x=trim($x);$y=trim($y);
		if($x=="Name")
		{
			list(,$t)=each($r);
			list(,$c)=explode(":",$t,2);
			$c=trim($c);
			list(,$t)=each($r);
			list(,$i)=explode(":",$t,2);
			$i=trim($i);
			$list[]=array($y,$c,$i);
		}
	}
	
	?><div>
		<br />
		<table class="dextable">
		<tr><th>Module</th><th>Count</th></tr>
		<?
			while(list(,list($x,$c,$i))=each($list))
			{
				if($x)echo "<tr".(($i=="True")?" class=\"active\"":"")."><td>".htmlentities($x)."</td><td>".htmlentities($c)."</td></tr>\n";
			}
		?>
		</table>				
		</div>
	<?
	$did=true;
}

function do_search()
{
	global $set,$_stor;
	
	if($_GET["q"])
	{
		if($_GET["s"])
		{
			$q=&$_stor[$_GET["s"]];
		}
		if(!$q)
		{
			$set["sid"]=md5(uniqid(rand()));
			exec("beagle-query --verbose -- ".escapeshellcmd($_GET["q"]),$q);
			$_stor[$set["sid"]]=&$q;
		}
		
		if(!$_GET["p"])$_GET["p"]=1;
		$page=&$_GET["p"];
		$first=($set["perpage"]*$page)-$set["perpage"];
		$last=$first+$set["perpage"]-1;
				
		if(is_array($q))
		{
			reset($q);
			list(,$t)=each($q);
			$stats["First Hit"]=trim($t);
			
			$h=-1;
			while(list(,$t)=each($q))
			{
				if(trim($t))
				{
					if(substr($t,0,4)=="    ")
					{
						list($x,$y)=explode("=",$t,2);
						$x=trim($x);$y=trim($y);
						$w=explode(":",$x);
						if($y=="(null)")$y=NULL;
						switch(count($w))
						{
							default:$r[$h][$x]=$y;break;
							case 2:$r[$h][$w[0]][$w[1]]=$y;break;
							case 3:$r[$h][$w[0]][$w[1]][$w[2]]=$y;break;
							case 4:$r[$h][$w[0]][$w[1]][$w[2]][$w[3]]=$y;break;
							case 5:$r[$h][$w[0]][$w[1]][$w[2]][$w[3]][$w[4]]=$y;break;
						}
					}
					else
					{
						list($x,$y)=explode(":",$t,2);
						$x=trim($x);$y=trim($y);
						if($y=="(null)")$y=NULL;
						if($x=="Uri")
						{
							$h++;
							$r[$h]["UriNU"]=str_replace("file:///","/",$y);
						}
						//$set["sid"]
						if($x=="Elapsed time"||$x=="Total hits")
						{
							$stats[$x]=$y;
							continue;
						}
						
						$r[$h][$x]=$y;
					}
				}
			}
		}
		
		if($last<$stats["Total hits"]) $stats["Last"]=$last;
		else $stats["Last"]=$stats["Total hits"]-1;
		if($first<=$stats["Last"]) $stats["First"]=$first;
		else $stats["First"]=$stats["Last"];
		$stats["Pages"]=ceil($stats["Total hits"]/$set["perpage"]);
				
		?>
			<div class="leadline">
				<?if($stats["Total hits"]>$stats["Last"]+1||$stats["Pages"]){?><?=$stats["First"]+1?> to <?=$stats["Last"]+1?> of <?}?><?if($stats["Total hits"]){?><b><?=$stats["Total hits"]?></b> Results<?} else {?><b>No results</b><?}?> <?if($stats["Elapsed time"]){?>(<b><?=$stats["Elapsed time"]?></b>)<?}?>
			</div>
		<?
		
		if(is_array($r)&&count($r))
		{
			reset($r);
			for($xloop=$stats["First"];$xloop<=$stats["Last"];$xloop++)
			{
				echo "<div class=\"resultsblock\"><div class=\"results\">\n";
				do_result(&$r[$xloop]);
				echo "</div></div>\n";
			}
			
			do_pager($stats["Pages"]);
			
		}
		else "<b>Not found</b>\n";
	}
}

function do_control()
{
	global $set;
	
	?>
		<div class="leadline_t">
			Control
		</div>
		
		<br /><? if($_GET["terminate"]){?>
		<b>Peagle is terminated when this page is fully loaded.<br />Please mind to wait a minute before starting Peagle again.<br />Have a nice day!</b>
		<?}else{?>
		<a href="/control?terminate=true">Klick here</a> to terminate Peagle. You can shutdown Peagle on your own, by running <i>killall peagle</i>
		in the terminal.
		<?}?>
	<?
	
}


function do_settings()
{
	global $set,$preset;
	
	?>
		<div class="leadline_t">
			Settings<?=(($_GET["save"])?" saved.":"")?>
		</div>
		
		<form action="/settings" method="get">
		
		<br /><table class="settings_table">
			<tr><th>Setting</th><th>Value</th><th>Hints</th></tr>
			
			<tr><td colspan="3" class="xtop">Server-Settings</td></tr>
			
			<tr>
				<td>Address:</td>
				<td><input type="text" name="address" value="<?=htmlentities($set["address"])?>" /></td>
				<td class="hlp">Listen on this IP-Address (default: 127.0.0.1) ... <span class="hlp_red">You must restart Peagle after changing this flag!</span></td>
			</tr>
			<tr>
				<td>Port:</td>
				<td><input type="text" name="port" value="<?=htmlentities($set["port"])?>" /></td>
				<td class="hlp">Listen on this Port (default: 7324) ...  <span class="hlp_red">You must restart Peagle after changing this flag!</span></td>
			</tr>
			<tr>
				<td>Charset:</td>
				<td><input type="text" name="charset" value="<?=htmlentities($set["charset"])?>" /></td>
				<td class="hlp">The Character-Encoding to use (ISO-8859-15, UTF-8, BIG-5, ...)</td>
			</tr>
			
			<tr><td colspan="3" class="xtop">Preferences</td></tr>
			
			<tr>
				<td>Results per Page:</td>
				<td>
					<select name="perpage">
						<? for($xloop=5;$xloop<101;$xloop+=5) {?>
							<option value="<?=$xloop?>"<?=(($xloop==$set["perpage"])?" selected=\"selected\"":"")?>><?=$xloop?></option>
						<?}?>
					</select>
				</td>
				<td class="hlp">Number of Results per Page to show (default: 10)</td>
			</tr>
			<tr>
				<td>Thumbnail Width:</td>
				<td><input type="text" name="tn_max_w" value="<?=htmlentities($set["tn_max_w"])?>" /></td>
				<td class="hlp">Width-Limit for Image-Thumbnails (Default: 200)</td>
			</tr>
			<tr>
				<td>Thumbnail Height:</td>
				<td><input type="text" name="tn_max_h" value="<?=htmlentities($set["tn_max_h"])?>" /></td>
				<td class="hlp">Height-Limit for Image-Thumbnails (Default: 75)</td>
			</tr>
			
			<tr><td colspan="3" class="xtop">Desktop-Integration</td></tr>
			
			<tr>
				<td>Desktop-Environment/Starter:</td>
				<td>
					<select name="desktop">
						<? reset($preset["desktops"]);while(list(,$x)=each($preset["desktops"])) {?>
							<option value="<?=htmlentities($x)?>"<?=(($x==$set["desktop"])?" selected=\"selected\"":"")?>><?=htmlentities($x)?></option>
						<?}?>
					</select>
				</td>
				<td class="hlp">Select your Desktop-Environment / Link-Method. Set "auto", if you want to auto-detect it. Use "Custom" to specify an own way to open links.</td>
			</tr>
			<tr>
				<td>Custom Starter:</td>
				<td><input type="text" name="desktop_custom" value="<?=htmlentities($set["desktop_custom"])?>" /></td>
				<td class="hlp">If using "custom" Desktop-Environment/Starter, Specify here your starter-command. Use %p as
												placeholder for the Path or %u for the Uri. Example: <i>run-mailcap --action=view %p</i></td>
			</tr>
			
			<tr><td colspan="3" align="center"><input type="submit" name="save" value="Save" /> <input type="reset" name="reset" value="Reset" /></td>
		
		</table>		
		
		</form>
	<?

}

function do_pager($nump)
{
	global $set;
	if($nump>1)
	{
		$stop=$_GET["p"]+9;
		if($stop>$nump)$stop=$nump;
		$start=$_GET["p"]-10;
		if($start<1)$start=1;
		?>
		<div class="pager">
			<?
				if($_GET["p"]>1) {?><a href="<?=htmlentities($_SERVER["PHP_SELF"]."?q=".rawurlencode($_GET["q"])."&p=".rawurlencode($_GET["p"]-1)."&s=".rawurlencode($set["sid"]))?>">&lt; Prevous</a> | <?}
				
				for($xloop=$start;$xloop<=$stop;$xloop++)
				{
					?> <a href="<?=htmlentities($_SERVER["PHP_SELF"]."?q=".rawurlencode($_GET["q"])."&p=".rawurlencode($xloop)."&s=".rawurlencode($set["sid"]))?>"<?=(($xloop==$_GET["p"])?" class=\"selected\"":"")?>><?=$xloop?></a> <?
				}
				
				if($_GET["p"]<$nump) {?> | <a href="<?=htmlentities($_SERVER["PHP_SELF"]."?q=".rawurlencode($_GET["q"])."&p=".rawurlencode($_GET["p"]+1)."&s=".rawurlencode($set["sid"]))?>">Next &gt;</a> <?}
			?>
		</div>
		<?
		
	}
}

function do_searchblock()
{
	?>
	<table class="searchblock"><tr>
	<td><a href="/"><img src="/data/images/peagle_small.png" border="0" alt="Peagle" /></a></td>
	<form action="/search" method="get">
		<td><input type="text" name="q" value="<?=$_GET["q"]?>" /></td>
		<td><input type="submit" name="" value=" Search " /></td>
	</form>
	</tr></table>
	<?
}

function do_topper()
{
	?>
		<div class="topper">
			<a href="/status">Status</a>
			| <a href="/index">Index</a>
			| <a href="/settings">Settings</a>
			| <a href="/control">Control</a>
		</div>
	<?
}

function do_result($e)
{
	$absf="abstract/mod_".strtolower($e["Type"]).".php";
	if(is_file($absf)) {require_once($absf);$fnc=strtolower("abstract_".$e["Type"]);}
	else {require_once("abstract/mod_generic.php");$fnc="abstract_generic";}
	return(call_user_func($fnc,&$e));
}

function do_replace($a,$b,$c)
{
	if(!function_exists("str_ireplace"))return str_replace($a,$b,$c);
	else return str_ireplace($a,$b,$c);
}

function link_open($url)
{
	global $set;
	switch($set["desktop"])
	{
		case "kde":case "gnome":case "mailcap":case "custom":return("/open?o=".rawurlencode($url));break;
		case "link":return($url);break;
	}
}

function link_link($url)
{
	return($url);
}

function link_sendimg($url)
{
	return("/thumb?i=".rawurlencode($url));
}

function highlight($t)
{
	$sp=trim($_GET["q"]);
	if(strstr(":",$sp))list(,$sp)=explode(":",$sp,2);
	return(do_replace("$sp","<span>$sp</span>",$t));
}

function search_init()
{
	global $set;
	if($set["desktop"]=="auto")
	{
		//$dx=array();
		//exec("ps -Af | grep -q '[k]desktop' &>/dev/null && echo kde",$dx);
		//if($dx[0]=="kde")$set["desktop"]="kde";
		if($_ENV["GNOME_DESKTOP_SESSION_ID"]) $set["desktop"]="gnome";
		if($_ENV["KDE_FULL_SESSION"]) $set["desktop"]="kde";
	}
	if($set["desktop"]=="auto") $set["desktop"]="link";
	
	//exec("beagled --replace --bg &");
}

function server_term()
{
	global $socket,$rsocket;
	socket_close($socket);
	socket_close($rsocket);
}

/*
function server_sig_hdl($sn)
{
  switch ($sn)
  {
    case SIGTERM:
    	echo "TERM\n";
    	exit;
    break;
    case SIGHUP:
    break;
    default:
  	break;
  }
}
*/

function server_run()
{
	global $socket,$rsocket,$set,$preset;
	set_time_limit(0);
	ob_implicit_flush();
	posix_setsid();
	
	$pid=pcntl_fork();
	if($pid==-1)die("could not fork");
	else if($pid)exit();
	
	//foreach($hu as $h)if(!fclose($h))exit;
	//pcntl_signal(SIGTERM,"server_sig_hdl");
	//pcntl_signal(SIGHUP,"server_sig_hdl");
	
	$set["sid"]=0;
	
	if(($rsocket=socket_create(AF_INET,SOCK_STREAM,0))< 0) echo socket_strerror($rsocket)."\n";
	if(($ret=socket_bind($rsocket,$set["address"],$set["port"]))<0) echo socket_strerror($ret)."\n";
	if(($ret=socket_listen($rsocket,5))<0) echo socket_strerror($ret)."\n";
	
	register_shutdown_function("server_term");
	
	echo "Server ready.\n";
	
	while(true)
	{
		if(($socket=socket_accept($rsocket))<0) {echo socket_strerror($socket)."\n";}
		//$pid=pcntl_fork();
		//if(!$pid)
		//{
		while(true)
		{
			if (FALSE===($buf=socket_read($socket,2048))){echo socket_strerror($ret)."\n";break 2;}
			if(!$buf)continue;
			
			$rqst=explode("\r\n",$buf);
			$step=0;
			$runcnt=0;
			while(list(,$temp)=each($rqst))
			{
				switch($step)
				{
					case 0:
						list($cmd,$uri,$proto)=explode(" ",$temp,3);
						switch(strtoupper($cmd))
						{
							case "GET":
								$in_cmd["method"]=$cmd;
								$in_cmd["uri"]=$uri;
								$in_cmd["rproto"]=$proto;
								list($in_cmd["ps"],$in_cmd["pv"])=explode("/",$proto,2);
								if($in_cmd["pv"]<1.1)
								{
									http_resp(501,"Not Implemented");
									socket_close($socket);
								}
								$step=1;
							break;
							default:
								http_resp(501,"Not Implemented");
								socket_close($socket);
								break 3;
							break;
						}
					break;
					case 1:
						if(!$temp)$runcnt++;
						if($runcnt==2)$step=2;
						if(!$temp) break;
						list($x,$y)=explode(":",$temp,2);
						$x=trim(strtolower($x));$y=trim($y);
						$in_req[$x]=$y;
					break;
					case 2:
						echo "reached final\n";
					break;
				}
			}
			
			$rurl=strtolower($in_cmd["ps"])."://";
			$rurl.=$in_req["host"];
			$rurl.=$in_cmd["uri"];
			
			$in_url=parse_url($rurl);
			$qstr=explode("&",$in_url["query"]);
			$_GET=array();
			while(list(,$temp)=each($qstr))
			{
				list($x,$y)=explode("=",$temp,2);
				$y=str_replace("+"," ",$y);
				$x=rawurldecode($x);$y=rawurldecode($y);
				$_GET[$x]=$y;
			}
			
			$_SERVER["PHP_SELF"]=$in_url["path"];
			$_SERVER["SERVER_NAME"]=$in_req["host"];
			$_SERVER["SERVER_SOFTWARE"]="$preset[app_name]/$preset[app_version]";
			$_SERVER["SERVER_PROTOCOL"]=$in_cmd["rproto"];
			$_SERVER["REQUEST_METHOD"]=$in_cmd["method"];
			$_SERVER["QUERY_STRING"]=$in_url["query"];
			$_SERVER["HTTP_ACCEPT"]=$in_req["accept"];
			$_SERVER["HTTP_ACCEPT_CHARSET"]=$in_req["accept-charset"];
			$_SERVER["HTTP_ACCEPT_ENCODING"]=$in_req["accept-encoding"];
			$_SERVER["HTTP_ACCEPT_LANGUAGE"]=$in_req["accept-language"];
			$_SERVER["HTTP_CONNECTION"]=$in_req["connection"];
			$_SERVER["HTTP_HOST"]=$in_req["host"];
			$_SERVER["HTTP_REFERER"]=$in_req["referer"];
			$_SERVER["HTTP_USER_AGENT"]=$in_req["user-agent"];
			$_SERVER["REQUEST_URI"]=$in_cmd["uri"];
			
			list(,$sia)=explode("/",$_SERVER["PHP_SELF"],3);
			if(!$sia)$sia="search";
			
			//echo "Called object: $sia\n";
			
			ob_start();
			$sia=strtolower($sia);
			switch($sia)
			{
				default:
					http_404();
				break;
				case "search":case "status":case "index":case "settings":case "control":
					
					if($_GET["save"]&&$sia=="settings")
					{
						$cng=false;
						$rst=false;
						if($set["address"]!=$_GET["address"]) {$set["address"]=$_GET["address"];$cng=true;$rst=true;}
						if($set["port"]!=$_GET["port"]) {$set["port"]=$_GET["port"];$cng=true;$rst=true;}
						if($set["charset"]!=$_GET["charset"]) {$set["charset"]=$_GET["charset"];$cng=true;}
						if($set["perpage"]!=$_GET["perpage"]) {$set["perpage"]=$_GET["perpage"];$cng=true;}
						if($set["tn_max_w"]!=$_GET["tn_max_w"]) {$set["tn_max_w"]=$_GET["tn_max_w"];$cng=true;}
						if($set["tn_max_h"]!=$_GET["tn_max_h"]) {$set["tn_max_h"]=$_GET["tn_max_h"];$cng=true;}
						if($set["desktop"]!=$_GET["desktop"]) {$set["desktop"]=$_GET["desktop"];$cng=true;$rst=true;}
						if($set["desktop_custom"]!=$_GET["desktop_custom"]) {$set["desktop_custom"]=$_GET["desktop_custom"];$cng=true;$rst=true;}
						if($rst)
						{
							search_init();
						}
						if($cng)
						{
							$fp=fopen("settings.php","w");
							fwrite($fp,"<?\n\$set=".var_export($set,true).";\n?>\n");
							fclose($fp);
						}
					}
					
					http_resp(200,"OK");
					out("Date: ".gmdate("D, d M Y H:i:s",time())." GMT\r\n");
					out("Server: $preset[app_name]/$preset[app_version]\r\n");
					out("Content-Type: text/html; charset=$set[charset]\r\n");
					
					echo "<?xml version=\"1.0\" encoding=\"$set[charset]\"?>\n";
					?>
					<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
					<html xmlns="http://www.w3.org/1999/xhtml">
					<head>
						<title><?=(($_GET["q"])?htmlentities($_GET["q"])." - ":"")?>Peagle</title>
						
						<meta http-equiv="Content-Language" content="en" />
						<meta http-equiv="Content-Type" content="text/html; charset=$set[charset]" />
						<meta http-equiv="Expires" content="0" />
						
						<link rel="stylesheet" href="/data/peagle.css" />
						<link rel="shortcut icon" href="/data/images/favicon.ico" />
					</head>
					<body>
					<?
					
					do_topper();
					
					do_searchblock();
										
					switch($sia)
					{
						case "settings":
							do_settings();
						break;
						case "status":
							do_status();
						break;
						case "index":
							do_sindex();
						break;
						case "control":
							do_control();
						break;
						default:
							do_search();
						break;
					}
					
					?>
					</body>
					</html>
					<?
											
				break;
				case "open":
					
					switch($set["desktop"])
					{
						default: /*kde*/
							exec("kfmclient exec -- \"".$_GET["o"]."\"&");
							//exec("bash --login -c \"kfmclient exec -- \\\"".escapeshellcmd($_GET["o"])."\\\"\" &");
							http_resp(204,"No Content");
						break;
						case "gnome":
							exec("gnome-open \"".$_GET["o"]."\" &");
							http_resp(204,"No Content");
						break;
						case "custom":
							list(,,$p)=explode("/",$_GET["o"],3);
							exec(str_replace("%u","\"".$_GET["o"]."\"",str_replace("%p","\"$p\"",$set["desktop_custom"]))." &");
							http_resp(204,"No Content");
						break;
						case "mailcap":
							exec("run-mailcap --action=view \"".substr($_GET["o"],7)."\" &");
							http_resp(204,"No Content");
						break;
					}
					out("Date: ".gmdate("D, d M Y H:i:s",time())." GMT\r\n");
					out("Server: $preset[app_name]/$preset[app_version]\r\n");
					out("Content-Type: text/html; charset=$set[charset]\r\n");
				
				break;
				case "thumb":
					http_resp(200,"OK");
					out("Date: ".gmdate("D, d M Y H:i:s",time())." GMT\r\n");
					out("Server: $preset[app_name]/$preset[app_version]\r\n");
				
					list($w,$h,$t)=getimagesize($_GET["i"]);
					switch($t)
					{
						case 1:$ip=imagecreatefromgif($_GET["i"]);break;
						case 2:$ip=imagecreatefromjpeg($_GET["i"]);break;
						case 3:$ip=imagecreatefrompng($_GET["i"]);break;
					}
					if($ip)
					{
						$asr=$set["tn_max_w"]/$set["tn_max_h"];
						$asm=$h/$w;
						if($h>$set["tn_max_h"]||$w>$set["tn_max_w"])
						{
							if($asr<$asm)	{$ow=$set["tn_max_w"];$oh=$h*($set["tn_max_w"]/$w);}
							else					{$oh=$set["tn_max_h"];$ow=$w*($set["tn_max_h"]/$h);}
						}
						else
						{
							$ow=$w;$oh=$h;
						}
						$op=imagecreatetruecolor($ow,$oh);
						imagecopyresampled($op,$ip,0,0,0,0,$ow,$oh,$w,$h);
						out("Content-Type: image/jpeg\r\n");
						imagejpeg($op,null,80);
					}
				
				break;
				case "data":
				
					$df="data/".substr($_SERVER["PHP_SELF"],6);
					if(is_file($df))
					{
						http_resp(200,"OK");
						out("Date: ".gmdate("D, d M Y H:i:s",time())." GMT\r\n");
						out("Server: $preset[app_name]/$preset[app_version]\r\n");
						readfile($df);
					}
					else http_404();
				break;
			}
						
			out("\r\n");
			out(ob_get_contents());
			ob_end_clean();			
			
			if($_GET["terminate"]&&$sia=="control") exit;
			
			break;
		}
		
		//}
		socket_close($socket);
	}
	
	socket_close($rsocket);

}

function http_resp($code,$comment)
{
	out("HTTP/1.1 $code $comment\r\n");
}

function out($t)
{
	global $socket;
	return(socket_write($socket,$t,strlen($t)));
}

function http_404()
{
	global $set,$preset;
	http_resp(404,"Not Found");
	out("Date: ".gmdate("D, d M Y H:i:s",time())." GMT\r\n");
	out("Server: $preset[app_name]/$preset[app_version]\r\n");
	out("Content-Type: text/html; charset=$set[charset]\r\n");
	
	echo "<b>Not found!</b>";
}

?>