<?

function abstract_file($a)
{
	$type="File";

	?>
		<div>
			<div class="headline"><a href="<?=htmlentities(link_open($a["Uri"]))?>"><?=highlight(htmlentities($a["beagle"]["ExactFilename"]))?></a></div>
			<div class="snip">
				<?=(($a["Snip"])?$a["Snip"]:"")?>
				<?
					//echo $a["beagle"]["MimeType"];
					list($mime1,$mime2)=explode("/",$a["beagle"]["MimeType"],2);
					switch(strtolower($mime1))
					{
						case "audio":
							$type="Audio";
							if(is_array($a["fixme"]))
							{
								$w="";
								while(list($x,$y)=each($a["fixme"]))
								{
									$w.=htmlentities($x).": ".htmlentities($y)."<br />\n"; 
								}
								if($w) echo highlight($w);
							}
						break;
						case "video":
							$type="Video";
						break;
						case "text":
							$type="Text";
							switch($mime2)
							{
								case "x-csrc":$type="C-Sourcecode";break;
								case "x-chdr":$type="C-Header";break;
								case "html":$type="Web-Document";break;
							}
						break;
						case "image":
							$type="Image";
							if($mime2=="png"||$mime2=="jpeg"||$mime2=="gif") echo "<a href=\"".htmlentities(link_open($a["Uri"]))."\"><img src=\"".htmlentities(link_sendimg($a["UriNU"]))."\" border=\"0\" alt=\"".htmlentities($a["beagle"]["ExactFilename"])."\" /></a>\n";
						break;
						case "inode":
							if($mime2=="directory")
							{
								$type="Directory";
								$dp=opendir($a["UriNU"]);
								$cn="";
								if($dp)
								{
									$lim=7;
									while($t=readdir($dp)) {if($t!="."&&$t!=".."&&$lim>0)$cn.=", $t"; elseif(!$lim) $cn.=", ... (more)";$lim--;}
									//if(readdir($dp)) 
									closedir($dp);
								}
								$cn=substr($cn,2);
								if($cn) echo highlight($cn);
							}
						break;
						case "application":
							switch($mime2)
							{
								case "x-desktop":$type="Application-Link";break;
								case "pdf":$type="PDF-Document";break;
								case "x-php":$type="PHP-Script";break;
								case "msword":$type="Word-Document";break;
								case "vnd.ms-excel":$type="Excel-Sheet";break;
								case "vnd.oasis.opendocument.text":$type="OpenDocument-Text";break;
								case "vnd.oasis.opendocument.spreadsheet":$type="OpenDocument-Spreadsheet";break;
								case "vnd.oasis.opendocument.presentation":$type="OpenDocument-Presentation";break;
							}
						break;
					}
				?>
			</div>
			<div class="subline">
				<?=htmlentities($type)?>
				- <?=highlight(htmlentities($a["UriNU"]))?>
				<?=(($a["Time"])?" - ".htmlentities($a["Time"]):"")?>
			</div>
		</div>
	<?

}

?>